%define	oldlzmaver	4.32.7
%define	major	0
%define libname %mklibname lzmadec %{major}
%define libdev  %mklibname -d lzmadec


%define build_dkms 0

Summary: 	LZMA utils
Name: 		lzma
Version: 	4.43
Release: 	%mkrel 45
License: 	GPL
Group:		Archiving/Compression
Source0:	https://tukaani.org/lzma/lzma-%{oldlzmaver}.tar.lzma
Source1:	https://downloads.sourceforge.net/sevenzip/lzma443.tar.bz2
#Source2:	lzme
Source3:	sqlzma.h
#Patch0:	lzma-432-makefile.patch.bz2
#Patch1:	lzma-432-makefile-sdknew.patch.bz2
#Patch2:	lzma-4.43-lzmp.patch

# (blino) modified for 443, from sqlzma1-449.patch:
#   * adapted to lzma443 dist structure: s,/C/Compress/Lzma/,/C/7zip/Compress/LZMA_C/,; s,/CPP/7zip/Compress/LZMA_Alone/,/C/7zip/Compress/LZMA_Alone/,
#   * use sqlzma.mk makefiles for 443 (from from sqlzma1-443.patch)
#   * remove NCoderPropID::kNumThreads in comp.cc, it is invalid since we don't build LZMAEncoder.cpp with COMPRESS_MF_MT multithread support
Patch3:		lzma-4.32.4-sqlzma.patch

Patch4:		lzma-4.43-add-missing-header.patch
Patch5:		lzma-4.43-quiet.patch
Patch6:		lzma-4.43-update-version.patch
Patch7:		lzma-4.43-fix-fast-compression.patch
Patch8:		lzma-4.43-add-missing-gethandle.patch
Patch9:		lzma-4.32.4-text-tune.patch
#Patch10:	lzma-4.32.0beta3-fix-stdout.patch
#Patch11:	lzma-4.43-fix-liblzmadec-header-includes.patch
# 4.32.2 has changes to sdk that we replace with newer, we apply these to the new
Patch12:	lzma-4.32.2-sdk-changes.patch
#Patch13:	lzma-4.32.2-file_modes.patch
#Patch14:	lzma-4.32.3-liblzmadec-fix.patch
#Patch15:	lzma-4.32.5-fix-deprecated-string-conversion.patch
Patch16:	lzma-4.32.7-format_not_a_string_literal_and_no_format_arguments.diff
# for squashfs-lzma library
BuildRequires:	pkgconfig(zlib)
BuildRequires:	dos2unix
BuildRequires:	diffutils
URL:		https://tukaani.org/lzma/

%if !%build_dkms
Obsoletes:	dkms-%{name} < %{version}-%{release}
%endif

%description
LZMA provides very high compression ratio and fast decompression. The
core of the LZMA utils is Igor Pavlov's LZMA SDK containing the actual
LZMA encoder/decoder. LZMA utils add a few scripts which provide
gzip-like command line interface and a couple of other LZMA related
tools. Also provides:

- Average compression ratio 30% better than that of gzip and 15%
  better than that of bzip2.

- Decompression speed is only little slower than that of gzip, being
  two to five times faster than bzip2.

- In fast mode, compresses faster than bzip2 with a comparable
  compression ratio.

- Achieving the best compression ratios takes four to even twelve
  times longer than with bzip2. However. this doesn't affect
  decompressing speed.

- Very similar command line interface than what gzip and bzip2 have.

%package -n	%{libname}
Summary:	Libraries for decoding LZMA compression
Group:		System/Libraries
License:	LGPL
Provides:	%{_lib}%{name}%{major} = %{version}-%{release}
Obsoletes:  %{_lib}%{name}%{major} <= %{version}-%{release}

%description -n	%{libname}
Libraries for decoding LZMA compression.

%package -n	%{libdev}
Summary:	Devel libraries & headers for liblzmadec
Group:		Development/C
License:	LGPL
Provides:	lzmadec-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Requires:	%{libname} = %{version}

%description -n %{libdev}
Devel libraries & headers for liblzmadec.

%package -n	dkms-%{name}
Summary:	Kernel modules for decoding LZMA compression
Group:		System/Kernel and hardware
License:	GPL
Requires(post):	dkms
Requires(preun):	dkms

%description -n	dkms-%{name}
Kernel modules for decoding LZMA compression.

%prep
%setup -q -n %{name}-%{oldlzmaver} -a1
#%patch -P 0 -p1 -b .427
#%patch -P 1 -p1 -b .427_sdk
#%patch -P 2 -p1
%patch -P 3 -p1 -b .sqlzma
cp %{SOURCE3} .
dos2unix *.txt

# ugly syncing with latest sdk
mv src/sdk src/sdk.old
cp -r C src/sdk
for i in `find src/sdk.old -name Makefile.\*`; do
	cp $i `echo $i|sed -e 's#sdk.old#sdk#g'`;
done

find src/sdk -name makefile|xargs rm -f

%patch -P 4 -p1 -b .config_h
%patch -P 5 -p1 -b .quiet
%patch -P 6 -p0 -b .version
%patch -P 7 -p0 -b .fast
%patch -P 8 -p0 -b .gethandle
%patch -P 9 -p1 -b .text
#%patch -P 10 -p1 -b .stdout
#%patch -P 11 -p1 -b .lzmadec_systypes
%patch -P 12 -p1 -b .4.32.2
#%patch -P 13 -p1 -b .file_modes
#%patch -P 14 -p1 -b .liblzmadec_fix
#%%patch -P 15 -p0 -b .fix_string_conversion
%patch -P 16 -p1 -b .format_not_a_string_literal_and_no_format_arguments

%if %build_dkms
pushd C/7zip/Compress/LZMA_C
cp %{SOURCE3} kmod/
cp uncomp.c LzmaDecode.{c,h} LzmaTypes.h kmod/
perl -pi -e 's,^#include "\.\./(Lzma.*)",#include "$1",' kmod/*.{c,h}
cat > kmod/dkms.conf <<EOF
PACKAGE_NAME=%{name}
PACKAGE_VERSION=%{version}-%{release}
DEST_MODULE_LOCATION[0]="/kernel/lib/%{name}"
DEST_MODULE_LOCATION[1]="/kernel/lib/%{name}"
BUILT_MODULE_NAME[0]="sqlzma"
BUILT_MODULE_NAME[1]="unlzma"
AUTOINSTALL=yes
EOF
popd
%endif

%build
# to recongnize aarch64
autoreconf -vfi

CFLAGS="%{optflags} -D_FILE_OFFSET_BITS=64 -O3" \
CXXFLAGS="%{optflags} -D_FILE_OFFSET_BITS=64 -O3" \
%configure
%make_build
%make_build CFLAGS="%{optflags} -c -Wall -pedantic -D _LZMA_PROB32  -DNDEBUG -include pthread.h -I../../../.." -C C/7zip/Compress/LZMA_C -f sqlzma.mk Sqlzma=../../../..
%make_build CFLAGS="%{optflags} -c -I ../../../" -C C/7zip/Compress/LZMA_Alone -f sqlzma.mk Sqlzma=../../../..

%install
%make_install
#install -m755 %{SOURCE2} -D %{buildroot}%{_bindir}/lzme

rm -f %{buildroot}%{_libdir}/*.la

#symlink to provide backward compatibility for stuff still using old 'lzmash' script
#ln -s lzma %{buildroot}%{_bindir}/lzmash
install C/7zip/Compress/LZMA_*/*.a %{buildroot}%{_libdir}

%if %build_dkms
mkdir -p %{buildroot}/usr/src/%{name}-%{version}-%{release}/
tar c -C C/7zip/Compress/LZMA_C/kmod . | tar x -C %{buildroot}/usr/src/%{name}-%{version}-%{release}/
%endif

rm -rf %{buildroot}{%{_bindir},%{_mandir}}

%check
make check

%if %build_dkms
%post -n dkms-%{name}
set -x
/usr/sbin/dkms --rpm_safe_upgrade add -m %{name} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{name} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{name} -v %{version}-%{release}
:

%preun -n dkms-%{name}
set -x
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{name} -v %{version}-%{release} --all
:
%endif

%files -n %{libname}
%{_libdir}/lib*.so.%{major}
%{_libdir}/lib*.so.%{major}.*

%files -n %{libdev}
%doc *.txt
%{_includedir}/*.h
%{_libdir}/*.so
%{_libdir}/*.a

%if %build_dkms
%files -n dkms-%{name}
/usr/src/%{name}-%{version}-%{release}
%endif


%changelog
* Sun Dec 22 2024 pterjan <pterjan> 4.43-45.mga10
+ Revision: 2127826
- Rebuild for patchN deprecation

* Thu Mar 17 2022 umeabot <umeabot> 4.43-44.mga9
+ Revision: 1797534
- Mageia 9 Mass Rebuild

* Sat Feb 13 2021 neoclust <neoclust> 4.43-43.mga8
+ Revision: 1675263
- Rebuild because of missing rpms

* Sat Feb 13 2021 neoclust <neoclust> 4.43-42.mga8
+ Revision: 1675247
- Do not provide dkms module

* Thu Feb 13 2020 umeabot <umeabot> 4.43-41.mga8
+ Revision: 1514961
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Sun Sep 23 2018 umeabot <umeabot> 4.43-40.mga7
+ Revision: 1299423
- Mageia 7 Mass Rebuild

* Sun Jun 03 2018 wally <wally> 4.43-39.mga7
+ Revision: 1233857
- fix build on aarch64

* Fri Aug 26 2016 akien <akien> 4.43-38.mga6
+ Revision: 1049175
- Fix devel lib provides

* Fri Feb 05 2016 umeabot <umeabot> 4.43-37.mga6
+ Revision: 938664
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 4.43-36.mga5
+ Revision: 740525
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 4.43-35.mga5
+ Revision: 682108
- Mageia 5 Mass Rebuild

* Fri Oct 18 2013 umeabot <umeabot> 4.43-34.mga4
+ Revision: 507686
- Mageia 4 Mass Rebuild

* Sat Jan 12 2013 umeabot <umeabot> 4.43-33.mga3
+ Revision: 359226
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Feb 05 2011 spuhler <spuhler> 4.43-32.mga1
+ Revision: 47598
- increase rel to 32 to be built
- removed buildroot definition from .spec

* Sat Jan 08 2011 blino <blino> 4.43-31.mga1
+ Revision: 1134
- remove old ldconfig scriptlets
- imported package lzma

